#!/usr/bin/python
# -*- coding: utf-8 -*-

# attention: pour les accents, ce fichier doit être impérativement
#      lu et modifié sous éditeur avec encodage UTF-8

################################################################
######                                                    ######
######                    CALCULEXT                       ######
######                                                    ######
######         ===> Calculatrice Extensible <===          ######
######                                                    ######
######                   Version 1.40                     ######
######                                                    ######
################################################################

# Copyright (C) 2008 Jean-Paul Vidal dit "Tyrtamos" — Tous droits réservés.
#   Logiciel distribué gratuitement sur le site <http://linux.jpvweb.com>
#
#   Ce programme est un logiciel libre. Vous pouvez le redistribuer ou le
#   modifier suivant les termes de la "GNU General Public License" version 3,
#   telle que publiée par la Free Software Foundation.
#
#   Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
#   AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
#   ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
#   Publique GNU pour plus de détails.
#
#   Ce programme doit être distribué avec une copie de la
#   License Générale Publique GNU (fichier license.html).
#   Si ce n’est pas le cas, consultez: <http://www.gnu.org/licenses/gpl.html>.

##################################################################
# Importation du module "division" nécessaire pour Python version 2.4 et 2.5:
# les divisions entre 2 entiers doivent être décimales et pas entières!
# par exemple: 10/3 donnera "3.33333333333333" et pas "3"
# (les divisions entières seront désormais faites avec "//")
from __future__ import division

##################################################################
# Identification de la version
__version__="1.40"
__build__="0.0"
__date__="8/7/2008"

##################################################################
# Importation des modules nécessaires au fonctionnement de la calculatrice
#
import Tkinter
import tkFileDialog
import tkMessageBox
import tkFont
import imp  # nécessaire à cause de l'option py2exe pour Windows
import os

import sys
reload(sys)  # force l'interpréteur Python à fonctionner avec l'encodage utf-8
if hasattr(sys,"setdefaultencoding"):
    sys.setdefaultencoding("utf-8")

settrace = sys.settrace
exc_info = sys.exc_info
argv = sys.argv
maxint = sys.maxint
setcheckinterval = sys.setcheckinterval

import threading
import types  # nécessaire pour les fonctions de vérification de types

import webbrowser  # nécessaire pour la consultation du manuel
import time  # pour avoir le temps de calcul CPU
import locale  # pour avoir le temps en français
import datetime

# Importation des modules nécessaires aux calculs
#
from math import *  # fonctions transcendantes habituelles (sinus, log, ...)
from decimal import *  # nombres décimaux de précision quelconque et sans erreur de stockage
from random import *  # permet de générer des nombres au hasard
import cmath  # modules de fonctions transcendantes pour les nombres complexes

# importation des modules additionnels
#    ajoutez ici les modules que vous avez créés
#    et mettez en commentaire ceux que vous n'utilisez pas (attention aux dépendances)
#
from bibgene import *
from conversions import *
from arithmetique import *
from combinatoire import *
from probabilite import *
from credit import *
from temps import *

##################################################################
# Déclaration des variables globales

# préparation du menu flottant, appelé par un clic droit sur la zone de saisie
chmenu=(
        ("[Priorité des opérateurs]",
            "$`xxxx` : évaluation de chaîne",
            "${} : dictionnaire",
            "$[] : liste",
            "$() : parenthèses ou tuple",
            "$f() : appel de fonction",
            "$x[i1:i2] : découpage ",
            "$x[i] : indexation ",
            "$xxx.attribut : référence",
            "$** : puissance ",
            "$~ : non binaire",
            "$+, - : positif, négatif",
            "$*, /, //, % : mult, div, modulo",
            "$+, - : addition, soustraction",
            "$<<, >> : décalage binaire",
            "$& : et binaire",
            "$^ : ou exclusif binaire",
            "$| : ou binaire",
            "$<, <=, >, >=, !=, == : comparaisons",
            "$is, not is : test d'identité",
            "$in, not in : test d'appartenance",
            "$not : non logique",
            "$and : et logique",
            "$or : ou logique",
            "$lambda : expression lambda"
            ),
        ("Fonctions de conversion",
            "int(x)",
            "long(x)",
            "float(x)",
            "str(x)",
            "repr(x)",
            "list(x)",
            "",
            "hex(n)",
            "oct(n)",
            "dec2bin(d,nb=0)",
            "dec2bins(d,nb=0)",
            "bin2dec(chaîne binaire)",
            "bin2decs(chaîne binaire)",
            "",
            "ord(caractère ASCII)",
            "chr(num ASCII)",
            "",
            "degrees(x)",
            "radians(x)",
            "deg2dms(degrés décimaux)",
            "dms2deg([deg,min,sec])",
            "dec2gray(x,nb=8)",
            "gray2dec(chaîne binaire)"
            ),
        ("Fonctions diverses",
             "aide(fonction)",
             "sto('X',expression)",
             "arrond(x,n=-15)",
             "precision(n=-15)",
             "len(S)",
             "lambda :",
             "map(fonction,[paramètres])",
             "jeuxdessais(n,L1,L2)",
             "volcuve(h,d,vt)",
             "mdp2hex(ch)",
             "hex2mdp(ch)",
             "triliste(L,direct=True)",
             "random()",
             "fnimplicite(fn,x1,dx,eps=1.0e-15)",
             "fnimplicite2(fn,x1,dx,eps=1.0e-15)"
             ),
        ("Fonctions transcendantes",
            "pi",
            "e",
            "",
            "pow(x,y)",
            "sqrt(x)",
            "exp(x)",
            "log(x)",
            "log10(x)",
            "hypot( x, y)",
            "",
            "sin(r)",
            "cos(r)",
            "tan(x)",
            "",
            "asin(x)",
            "acos(x)",
            "atan(x)",
            "",
            "sinh(x)",
            "cosh(x)",
            "tanh(x)"
            ),
        ("Module 'decimal'",
            "Decimal()",
            "precisiondecimal(n=28)"
            ),
        ("Nombres complexes",
            "complex(nb réel, nb imaginaire)",
            ".real",
            ".imag",
            ".conjugate()",
            "",
            "cmath.sqrt(x)",
            "cmath.exp(x)",
            "cmath.log(x)",
            "cmath.log10(x)",
            "",
            "cmath.sin(x)",
            "cmath.cos(x)",
            "cmath.tan(x)",
            "",
            "cmath.asin(x)",
            "cmath.acos(x)",
            "cmath.atan(x)",
            "",
            "cmath.sinh(x)",
            "cmath.cosh(x)",
            "cmath.tanh(x)",
            "",
            "cmath.asinh(x)",
            "cmath.acosh(x)",
            "cmath.atanh(x)"
            ),
        ("Calculs arithmétiques",
            "fact(n)",
            "pgcd(a,b)",
            "ppcm(a,b)",
            "facteurs(n)",
            "mulfacteurs(L)",
            "estpremier(n)",
            "premiers(n)"
            ),
        ("Analyse combinatoire",
            "permut(n)",
            "permutliste(L,r=0)",
            "permutchaine(ch,r=0)",
            "",
            "arrang(n,k)",
            "arrangliste(L,k)",
            "arrangchaine(ch,k)",
            "",
            "combin(n,k)",
            "combinliste(L,k)",
            "combinchaine(ch,k)"
            ),
        ("Calculs de probabilités",
            "binom(k,n,p)",
            "binomcum(k,n,p)",
            "binomconfsup(k,n,conf)",
            "binomconfinf(k,n,conf)",
            "binomconf(k,n,conf)",
            "hbinom(n,p,nb=0)",
            "",
            "hypgeo(k,n,g,t)",
            "hypgeocum(k,n,g,t)",
            "",
            "poisson(k,m)",
            "poissoncum(k,m)",
            "poissonconfsup(k,conf)",
            "poissonconfinf(k,conf)",
            "poissonconf(k,conf)",
            "hpoisson(m,nb=0)",
            "",
            "pgauss(x,m,s)",
            "xgauss(p,m,s)",
            "hgauss(m,s,n=0)"
            ),
        ("Calculs de crédits",
            "menscredit(capital, intérêt%/an, nb de mois)",
            "moiscredit(capital, intérêt%/an, mensualité)",
            "capcredit(intérêt%/an, mensualité, nb de mois)",
            "intcredit(capital, mensualité, nb de mois)",
            "",
            "coutcredit(capital, mensualité, nb de mois, sup=0)"
            ),
        ("Dates et heures",
            "tempsordi()",
            "tempsntp(sntp='ntp.univ-lyon1.fr')",
            "",
            "cetteheure()",
            "sec2hms(secondes décimales)",
            "",
            "cejour()",
            "bissextile(an)",
            "nbjoursan(an)",
            "numjouran(D)",
            "datenumjouran(n,an)",
            "postdate(D1,D2)",
            "diffdate(D1,D2)",
            "adddate(D,n)",
            "numjoursem(D)",
            "joursem(D)",
            "lundi(D)",
            "debmoissuivant(D)",
            "estweekend(D)",
            "",
            "paques(an)",
            "ascension(an)",
            "pentecote(an)",
            "feries(an,sd=1)",
            "estferie(D,sd=1)",
            "diffdateouvre(D1,D2,sd=1)",
            "phaseslune(D,n)",
            "phaseslune2(D1,D2)"
            )
        )

# pile historique pour conserver les expressions précédentes ainsi que le dernier résultat
pile=[]
courpile=-1

# mode d'affichage pour les nombres à virgule flottante (voir fonction d'affichage)
nbchiffres=-15

# dictionnaire des variables utilisateurs
varutils={}

###############################################################################
# dit si un nombre est "entier", ou "entier long" (renvoie True ou False)
#
def estentier(n):
    """estentier(n): dit si une variable est un nombre entier ou entier long ou flottant sans décimale (renvoie True ou False)"""
    return isinstance(n,(types.IntType,types.LongType)) or (isinstance(n,types.FloatType) and (int(n)==n))

###############################################################################
# dit si un nombre est entier, long ou flottant (renvoie True ou False)
#
def estnombre(n):
    """estnombre(n): dit si une variable est un nombre entier, long ou flottant (renvoie True ou False)"""
    return isinstance(n,(types.IntType,types.LongType,types.FloatType))

###############################################################################
# dit si une variable est une chaîne (unicode ou non) (renvoie True ou False)
#
def estchaine(t):
    """estchaine(t): dit si une variable est une chaîne (unicode ou non) (renvoie True ou False)"""
    return isinstance(t,(types.StringTypes))

###############################################################################
# dit si une variable est une liste (renvoie True ou False)
#
def estliste(L):
    """estliste(L): dit si une variable est une liste (renvoie True ou False)"""
    return isinstance(L,(types.ListType))

###############################################################################
# dit si une variable est un tuple (renvoie True ou False)
#
def esttuple(T):
    """esttuple(T): dit si une variable est un tuple (renvoie True ou False)"""
    return isinstance(T,(types.TupleType))

###############################################################################
# dit si une variable est un dictionnaire (renvoie True ou False)
#
def estdict(D):
    """estdict(D): dit si une variable est un dictionnaire (renvoie True ou False)"""
    return isinstance(D,(types.DictType))

###############################################################################
# dit si un nombre est entier, long ou flottant (renvoie True ou False)
#
def estfonction(f):
    """estfonction(f): dit si f est un nom de fonction intégrée, utilisateur ou lambda (renvoie True ou False)"""
    return isinstance(f,(types.BuiltinFunctionType,types.FunctionType))

###############################################################################
# permet de changer la précision du module decimal
#
def precisiondecimal(n=28):
    """precisiondecimal(n): permet de changer la précision du module decimal (28 par défaut)"""
    # Vérif des données
    if (not estnombre(n)) or (not estentier(n)) or (n<0):
        raise ValueError ("erreur precisiondecimal(n=28): n, optionnel, doit être un entier positif ou nul")
    # Calcul
    getcontext().prec=n
    return n

##################################################################
# Change le mode d'affichage de la virgule des nombres réels (type float) -17<=n<=17
#   si nbchiffres<0 => affichage intelligent à "nbchiffres" chiffres significatifs
#   sinon, affichage à "nbchiffres" chiffres après la virgule
#
def precision(n=-15):
    """precision(n=-15): change le mode d'affichage des nombres réels (type float) -15<=n<=15"""
    global nbchiffres
    # Vérif des données
    if (not estnombre(n)) or (not estentier(n)) or (n<-17) or (n>17):
        raise ValueError ("erreur precision(n=-15): n, optionnel, doit être un nombre entier -17<=n<=17")
    # Calcul
    nbchiffres=n
    if nbchiffres<0:
        return "affichage intelligent à "+str(abs(nbchiffres))+" chiffres significatifs"
    else:
        return "affichage à "+str(nbchiffres)+" chiffres après la virgule"

##################################################################
# Fonction récursive d'affichage des nombres réels à virgule flottante
# x: n'importe quel objet python à afficher, y compris liste, tuples et complexes
# n: définit le mode d'affichage des nombres flottants à utiliser:
#   si n<0 => affichage intelligent à n chiffres significatifs (defaut=-15)
#   sinon, affichage à n chiffres après la virgule
#
def arrond(x,n=-15):
    """arrond(x,n=-15): affichage des nombres réels à virgule flottante avec -15<=n<=15 (défaut n=-15)"""
    if type(x)==float:
        if n<0:
            f = "%." + str(abs(n)) + "g"
            return f % x
        else:
            f = "%." + str(n) + "f"
            return f % x
    elif type(x)==list:
        L = "["
        if len(x)>0:
            for i in range(0,len(x)):
                L += str(arrond(x[i],n)) + ","
            L=L[0:-1]
        L += "]"
        return L
    elif type(x)==tuple:
        L = "("
        if len(x)>0:
            for i in range(0,len(x)):
                L += str(arrond(x[i],n)) + ","
            L = L[0:-1]
        L += ")"
        return L
    elif type(x)==dict:
        L = "{"
        if x!={}:
            for k in x.keys():
                L += str(k) + ":" + str(arrond(x[k],n)) + ","
            L = L[0:-1]
        L += "}"
        return L
    elif type(x)==complex:
        L = "(" + arrond(x.real,n)
        if x.imag>=0:
            L += "+"
        L += arrond(x.imag,n) + "j)"
        return L
    elif type(x)==str:
        return '"%s"' % x
    else:
        return "%r" % x

##################################################################
# Fonction récursive d'affichage des nombres réels à virgule flottante
# x: n'importe quel objet python à afficher, y compris liste, tuples et complexes
# nbchiffres: variable globale qui définit le mode d'affichage courant des nombres réels
#
def affiche(x):
    """fonction utilitaire d'affichage des nombres réels"""
    global nbchiffres
    return arrond(x,nbchiffres)

##################################################################
# Création interactive de variables supplémentaires
# ex: sto("toto",120+3) crée la variable X=toto (si elle n'existait pas)
#   et lui affecte le résultat de l'expression 120+3, c'est à dire 123.
# Cette variable toto devient utilisable dans les calcules suivants
#
# -> X doit être un nom de variable valide entouré de guillemets ou d'apostrophes:
#      (1er car=une lettre; les car suivants: lettre, chiffre ou "_")
# -> E est une valeur ou une expression de n'importe quel type
#
# Le Le résultat de E est renvoyé comme résultat de sto. On peut donc utiliser sto
#     à l'intérieur d'une expression comme: 2*sto("x",123)/25
#
# Attention aux risques de conflit avec les variables déjà existantes
# => testez avant: si l'exécution de toto (sans guillemet) donne 'erreur',
#     alors, la variable toto n'existe pas et vous pouvez la créer sans pb
#
def sto(X,E):
    """sto(X,E): affecte le résultat de l'expression E à la variable X (ex: 'toto') qui est créée si elle n'existait pas"""
    global varutils
    varutils[X]=E
    return E

##############################################################
# Affiche l'aide sur une fonction donnée
#
def aide(fn):
    """aide(fn): affiche l'aide sur une fonction donnée fn"""
    return fn.__doc__.replace("\n"," ")

##################################################################
# Fonction pour mettre la calculatrice au centre de l'écran
#
def centrefenetre(fen):
    """place la fenêtre au milieu de l'écran"""
    def geoliste(g):
        r=[i for i in range(0,len(g)) if not g[i].isdigit()]
        return [int(g[0:r[0]]),int(g[r[0]+1:r[1]]),int(g[r[1]+1:r[2]]),int(g[r[2]+1:])]
    fen.update_idletasks()
    l,h,x,y=geoliste(fen.geometry())
    fen.geometry("%dx%d%+d%+d" % (l,h,(fen.winfo_screenwidth()-l)//2,(fen.winfo_screenheight()-h)//2))

##################################################################
# Fonction pour afficher la durée de chaque calcul
#  calcule la durée en "h mn s" à partir des secondes décimales
#  ex: afficheduree(55365.123654789) => "15h 22mn 45.124s"
#  - n'affiche les heures que si elles ne sont pas nulles
#  - n'affiche les minutes que si les heures et les minutes ne sont pas nulles
#  - les secondes sont toujours affichées en secondes décimales (millisecondes)
#  - si durée inférieure à la milliseconde, affiche "< 0.001s"
#
def afficheduree(sd):
    """afficheduree(sd): renvoie la durée en "h mn s" à partir des secondes décimales"""
    if sd<0.001:
        return "< 0.001s"
    sd,s=divmod(sd,60)
    h,m=divmod(sd,60)
    s=round(s,3)
    if h>0:
        hms="%dh %dmn %ss" % (h,m,s)
    elif m>0:
        hms="%dmn %ss" % (m,s)
    else:
        hms="%ss" % (s)
    return hms

##############################################################################
class Apropos(Tkinter.Toplevel):

    def __init__(self, master=None):
        Tkinter.Toplevel.__init__(self, master)
        self.title("A propos")
        self.mes="""
CALCULEXT version 1.40
Calculatrice scientifique extensible

Copyright 2007-2008 Jean-Paul Vidal dit "Tyrtamos"
Distribution sous license GPL v3
Site http://python.jpvweb.com
Version en ligne: http://calculext.jpvweb.com
            """
        police=tkFont.Font(self, size=12, family='Arial')
        self.L=Tkinter.Label(self, text=self.mes, bg='yellow', font=police).grid()
        centrefenetre(self)

##################################################################
# Création de la classe "Calcul" dans un thread (=processus "leger")
#   pour calculer les expressions en tâche de fond
#   utilise la classe modèle threadatuer définie au dessus
#
class Calcul(threading.Thread):

    def __init__(self,expr):
        """Initialise le thread ainsi que les variables de l'instance"""
        threading.Thread.__init__(self)
        # stocke l'expression à calculer
        self.expression=expr
        # initialise le drapeau qui permettra l'arrêt du calcul sur demande
        self.arretcalcul=False
        # création de la varaible d'instance qui portera le résultat:
        self.result=None

    def run(self):
        """Lance le calcul en tâche de fond et affiche le résultat"""
        global app, pile, courpile, varutils, settrace
        # sauvegarde du temps CPU au début du calcul
        tps = time.clock()
        try:
            # mise en place du traçage
            settrace(self.trace)
            # calcul de l'expression:
            self.result=eval(self.expression,globals(),varutils)
            # formatage du résultat pour préparer l'affichage
            self.result=affiche(self.result)
            # arrêt du traçage
            settrace(None)
            # Empilage de l'expression calculée dans la pile historique
            if len(pile)>0:
                pile.pop()
            pile.append(self.expression)
            # empilage du dernier résultat dans la pile historique
            pile.append(self.result)
            # courpile pointe sur la dernière expression et pas sur son résultat
            courpile=len(pile)-2
        except:
            # arrêt du traçage en cas d'erreur
            settrace(None)
            # Recup message d'erreur (erreur interne ou déclenchée par "raise")
            self.result="%s" % exc_info()[1]
        # Affichage du temps de calcul
        app.varduree.set("[" + afficheduree(time.clock()-tps) + "]")
        # affichage du résultat ou du message d'erreur
        app.varresultat.set(self.result)
        # ré-active la zone de saisie qui avait été désactivée au lancement du calcul
        app.saisie.config(state=Tkinter.NORMAL)
        # met le focus sur la zone de saisie
        app.saisie.focus_set()

    def trace(self, frame, event, arg):
        """méthode appelée à chaque ligne de code du calcul par eval()"""
        if event == 'line':
            if self.arretcalcul:
                raise  ValueError ("Arrêt du calcul demandé")
        return self.trace

    def stopcalcul(self):
        """ méthode appelée pour demander au thread de calcul de s'arrêter"""
        self.arretcalcul=True

##################################################################
# Création de la classe "Calculext"
#
class Calculext(Tkinter.Frame):

    def __init__(self, master=None):
        """ initialisation de la calculatrice"""

        # couleurs utilisées
        self.coulfond="#dbd7c5"
        self.coulres="#ffffaa"

        # exécution du constructeur initial de la classe Tkinter.Frame
        Tkinter.Frame.__init__(self, master, background=self.coulfond)

        # création de la barre de menu
        self.barremenu = Tkinter.Menu(self.master)

        # creation du menu "Fichier"
        self.fichier = Tkinter.Menu(self.barremenu, tearoff=0)
        self.barremenu.add_cascade(label="Fichier", underline=0, menu=self.fichier)
        self.fichier.add_command(label="Répertoire de travail", underline=0, command=self.reptravail)
        self.fichier.add_separator()
        self.fichier.add_command(label="Enregistre l'historique (remplace)", underline=0, command=self.sauvehistorique)
        self.fichier.add_command(label="Enregistre l'historique (ajoute)", underline=25, command=self.ajoutehistorique)
        self.fichier.add_command(label="Charge l'historique en mémoire", underline=0, command=self.chargehistorique)
        self.fichier.add_command(label="Efface l'historique en mémoire", underline=1, command=self.effacehistorique)
        self.fichier.add_separator()
        self.fichier.add_command(label="Enregistre le résultat sur disque", underline=14, command=self.sauveresultat)
        self.fichier.add_command(label="Vide le fichier resultat.txt", underline=0, command=self.videresultat)
        self.fichier.add_separator()
        self.fichier.add_command(label="Quitter", underline=0, command=self.master.destroy)

        # creation du menu "Edition"
        self.edition = Tkinter.Menu(self.barremenu, tearoff=0)
        self.barremenu.add_cascade(label="Edition", underline=1, menu=self.edition)
        self.edition.add_command(label="Couper", accelerator="Ctrl-X", underline=0, command = self.couper)
        self.edition.add_command(label="Copier", accelerator="Ctrl-C", underline=2, command = self.copier)
        self.edition.add_command(label="Coller", accelerator="Ctrl-V", underline=1, command = self.coller)

        # creation du menu "Effacer"
        self.barremenu.add_command(label="Effacer", underline=0, command=self.effacer)

        # creation du menu "Calculer"
        self.barremenu.add_command(label="Calculer", underline=0, command=self.calculer)

        # creation du menu "Stopper"
        self.barremenu.add_command(label="Stopper", underline=0, command=self.stopper)

        # creation du menu "Aide"
        self.aide = Tkinter.Menu(self.barremenu, tearoff=0)
        self.barremenu.add_cascade(label="Aide", underline=0, menu=self.aide)
        self.aide.add_command(label="Manuel", accelerator="F1", underline=0, command=self.aider)
        self.aide.add_command(label="A propos", underline=0, command = self.apropos)

        # afficher le menu
        self.master.config(menu=self.barremenu)
        # fin de la création du menu

        # prépa config police de caractère
        police=tkFont.Font(self, size=12, family='Courier')
        policelabel=tkFont.Font(self, size=12, family='Arial')
        policeduree=tkFont.Font(self, size=10, family='Arial')
        policepopup=tkFont.Font(self, size=10, family='Courier')

        # création d'un layout_manager sur self
        self.grid()

        # création de la zone de saisie des expressions à calculer
        self.varsaisie = Tkinter.StringVar()
        self.varsaisie.set("")
        self.saisie=Tkinter.Entry(self,  background="white", width=72, font=police, textvariable=self.varsaisie)

        self.saisie.event_add("<<gocalc>>", "<Return>","<KP_Enter>")
        self.saisie.bind("<<gocalc>>", self.calculer)
        self.saisie.bind("<Escape>", self.effacer)
        self.saisie.bind("<F1>", self.aider)
        self.saisie.bind("<Up>", self.exprprec)
        self.saisie.bind("<Down>", self.exprsuiv)
        self.saisie.bind("<F2>", self.stopper)
        if os.name=="mac":
            self.saisie.bind("<Shift-Button-1>", self.menupopup)
        else:
            self.saisie.bind("<Button-3>", self.menupopup)
        self.saisie.grid(row=0,column=0, columnspan=4,padx=3, pady=6)

        # création du texte "Résultat="
        self.egal=Tkinter.Label(self, background=self.coulfond, text="Résultat =")
        self.egal.config(font=policelabel)
        self.egal.grid(row=1,column=0, sticky="we", padx=3, pady=0)

        # création de la zone pour l'affichage du résultat
        self.varresultat = Tkinter.StringVar()
        self.varresultat.set("")
        self.resultat=Tkinter.Entry(self, background=self.coulres, width=56, textvariable=self.varresultat)
        self.resultat.config(font=police)
        self.resultat.event_add("<<gocalc2>>", "<Return>","<KP_Enter>")
        self.resultat.bind("<<gocalc2>>", self.calculer)
        self.resultat.bind("<Escape>", self.effacer)
        self.resultat.bind("<F1>", self.aider)
        self.resultat.bind("<Up>", self.exprprec)
        self.resultat.bind("<Down>", self.exprsuiv)
        self.resultat.bind("<F2>", self.stopper)
        self.resultat.grid(row=1,column=1, columnspan=3, sticky="we",padx=3, pady=0)

        # création de la zone pour l'affichage du temps de calcul
        self.varduree = Tkinter.StringVar()
        self.varduree.set("")
        self.duree=Tkinter.Label(self, background=self.coulfond, text="", width=10, textvariable=self.varduree)
        self.duree.config(font=policeduree)
        self.duree.grid(row=2,column=0, sticky="we", padx=3, pady=4)

        # création d'un ascenseur horizontal pour consulter plus facilement les lignes trop longues de résultat
        self.resultatScroll = Tkinter.Scrollbar ( self, orient=Tkinter.HORIZONTAL, command=self.scrollRoutine)
        self.resultatScroll.grid(row=2, column=1, columnspan=3, sticky="we", padx=3, pady=4)
        self.resultat["xscrollcommand"] = self.resultatScroll.set

        # Construction du menu pop-up qui apparaitra au clic droit sur la ligne de saisie
        self.menuflottant = Tkinter.Menu(self.saisie, tearoff = 0, bg="lightblue",font=policepopup)
        self.menu=[]
        for k in range(0, len(chmenu)):
            self.menu.append(Tkinter.Menu(self.menuflottant, tearoff=0, bg="lightblue", font=policepopup))
            for i in range(1, len(chmenu[k])):
                if chmenu[k][i]=="":
                    # si l'item est vide, on met un séparateur
                    self.menu[k].add_separator()
                elif chmenu[k][i][0]=="$":
                    # si l'item commence par "$", on n'affiche pas le "$" dans le menu et il n'y aura pas d'insertion
                    self.menu[k].add_command(label=chmenu[k][i][1:], command=lambda x=k, y=i: self.execmenu(chmenu[x][y]))
                else:
                    self.menu[k].add_command(label=chmenu[k][i], command=lambda x=k, y=i: self.execmenu(chmenu[x][y]))
            self. menuflottant.add_cascade(label=chmenu[k][0], menu=self.menu[k])

        # initialisation "à blanc" de calc pour que le 1er calc.isAlive() ne provoque pas une erreur
        self.calc=Calcul("")
        # fin de la création de la calculatrice: mettre le focus sur la zone de saisie
        self.saisie.focus_set()

    def scrollRoutine(self, *L):
        """ Assure la synchro entre l'ascenseur horizontal et la ligne des résultats"""
        oper=L[0]
        combien=L[1]
        if oper=="scroll":
            units=L[2]
            self.resultat.xview_scroll(combien, units)
        elif oper=="moveto":
            self.resultat.xview_moveto(combien)

    def calculer(self,event=None):
        """Lance le calcul de l'expression en tâche de fond (thread)"""
        if (self.varsaisie.get()!="") and (not self.calc.isAlive()):
            # effacement zones d'affichage et durée pendant le nouveau calcul
            self.varduree.set("")
            self.varresultat.set("")
            # désactivation de la zone de saisie pour empêcher un nouveau calcul
            self.saisie.config(state=Tkinter.DISABLED)
            # Lancement du thread de calcul avec l'expression à calculer
            self.calc=Calcul(self.varsaisie.get())
            self.calc.setDaemon(True)
            self.calc.start()

    def stopper(self,event=None):
        """Permet à l'utilisateur d'ordonner l'arrêt d'un calcul trop long"""
        if self.calc.isAlive():
            self.calc.stopcalcul()

    def reptravail(self,event=None):
        """Permet de changer le répertoire de travail"""
        # le répertoire de travail actuel est le répertoire courant
        rep=os.getcwd()
        rep = tkFileDialog.askdirectory(title="Changer le répertoire de travail", initialdir=rep, mustexist=True)
        if len(rep) > 0:
            os.chdir(rep)

    def sauvehistorique(self,event=None):
        """enregistre la pile sur disque en remplaçant le contenu précédent"""
        global pile
        if len(pile)>0:  # = on ne sauve pas une pile vide
            chemin=os.getcwd() + os.sep + "calculext.hst"
            try:
                f=open(chemin,'w')
                try:
                    f.write("%r\n" % pile)
                except:
                    tkMessageBox.showerror("Erreur", "impossible d'écrire dans le fichier calculext.hst")
                f.close()
            except:
                tkMessageBox.showerror("Erreur", "impossible d'ouvrir le fichier calculext.hst en écriture")

    def ajoutehistorique(self,event=None):
        """enregistre la pile sur disque en s'ajoutant au contenu précédent"""
        global pile
        if len(pile)>0:  # = on ne sauve pas une pile vide
            chemin=os.getcwd() + os.sep + "calculext.hst"
            try:
                f=open(chemin,'a')
                try:
                    f.write("%r\n" % pile)
                except:
                    tkMessageBox.showerror("Erreur", "impossible d'écrire dans le fichier calculext.hst")
                f.close()
            except:
                tkMessageBox.showerror("Erreur", "impossible d'ouvrir le fichier calculext.hst en écriture")

    def chargehistorique(self,event=None):
        """charge en mémoire l'historique sauvegardé sur disque et l'ajoute sous la pile courante"""
        global pile, courpile
        chemin=os.getcwd() + os.sep + "calculext.hst"
        try:
            f=open(chemin,'r')
            try:
                H=eval(f.readline().rstrip("\r\n"))
            except:
                tkMessageBox.showerror("Erreur", "impossible de lire dans le fichier calculext.hst")
            f.close()
            H.extend(pile)
            pile=H
            courpile=len(pile)-2
        except:
            tkMessageBox.showerror("Erreur", "impossible d'ouvrir le fichier calculext.hst en lecture ou n'existe pas")

    def effacehistorique(self,event=None):
        """vide la pile courante de l'historique en mémoire"""
        global pile, courpile
        pile=[]
        courpile=-1

    def sauveresultat(self,event=None):
        """sauve le dernier résultat calculé sur disque à la fin du fichier resultat.txt"""
        global pile
        if len(pile)>0:
            chemin=os.getcwd() + os.sep + "resultat.txt"
            try:
                f=open(chemin,'a')
                try:
                    f.writelines("%r\n" % pile[-1])
                except:
                    tkMessageBox.showerror("Erreur", "impossible d'écrire dans le fichier resultat.txt")
                f.close()
            except:
                tkMessageBox.showerror("Erreur", "impossible d'ouvrir le fichier resultat.txt en écriture")

    def videresultat(self,event=None):
        """vide le fichier resultat.txt du répertoire en cours"""
        global pile
        chemin=os.getcwd() + os.sep + "resultat.txt"
        try:
            f=open(chemin,'w')
            f.close()
        except:
            tkMessageBox.showerror("Erreur", "impossible d'ouvrir le fichier resultat.txt en écriture")

    def effacer(self,event=None):
        """efface les 3 zones (saisie, résultat et durée)"""
        if not self.calc.isAlive():
            self.varsaisie.set("")
            self.varresultat.set("")
            self.varduree.set("")
            self.saisie.focus_set()

    def aider(self,event=None):
        """affiche la notice dans le navigateur web par défaut"""
        # cette page doit être dans le même répertoire que la calculatrice
        chemin = rep_exec() + os.sep + 'calculext.html'
        webbrowser.open(chemin)
        self.saisie.focus_set()

    def apropos(self,event=None):
        """affiche la fenêtre 'A propos' """
        self.apr=Apropos()
        self.apr.focus_set()

    def exprprec(self,event):
        """touche 'flèche en haut' permet la remontée dans la pile des formules"""
        global pile, courpile
        if (not self.calc.isAlive()) and (courpile>0):
            courpile=courpile-1
            self.varsaisie.set(pile[courpile])
        self.saisie.focus_set()

    def exprsuiv(self,event):
        """ touche 'flèche en bas' permet le rappel du résultat ou descente dans la pile des formules"""
        global pile, courpile
        if (not self.calc.isAlive()) and (courpile<(len(pile)-1)):
            courpile=courpile+1
            self.varsaisie.set(pile[courpile])
        self.saisie.focus_set()

    def couper(self):
        # effacer l'éventuel contenu précédent du clipboard
        self.clipboard_clear()
        # sélectionner le widget qui a le focus et agir selon
        if self.focus_get()==self.saisie:
            try:
                # saisir le texte sélectionné 's' s'il y en a un
                a=self.saisie.index(Tkinter.ANCHOR)
                i=self.saisie.index(Tkinter.INSERT)
                if i<a:
                    a,i=i,a
                t = self.saisie.get()
                s = t[a:i]
                # remettre le texte dont on a retiré la sélection
                t = t[0:a] + t[i:]
                self.saisie.delete(0,Tkinter.END)
                self.saisie.insert(0, t)
                # mettre le curseur à l'endroit où il y avait la sélection
                self.saisie.icursor(a)
                # et envoyer le texte sélectionné dans le clipboard
                self.clipboard_append(s)
            except:
                pass
        elif self.focus_get()==self.resultat:
            try:
                # saisir le texte sélectionné 's' s'il y en a un
                a=self.resultat.index(Tkinter.ANCHOR)
                i=self.resultat.index(Tkinter.INSERT)
                if i<a:
                    a,i=i,a
                t = self.resultat.get()
                s = t[a:i]
                # remettre le texte dont on a retiré la sélection
                t = t[0:a] + t[i:]
                self.resultat.delete(0,Tkinter.END)
                self.resultat.insert(0, t)
                # mettre le curseur à l'endroit où il y avait la sélection
                self.resultat.icursor(a)
                # et envoyer le texte sélectionné dans le clipboard
                self.clipboard_append(s)
            except:
                pass
        else:
            pass

    def copier(self):
        # effacer l'éventuel contenu précédent du clipboard
        self.clipboard_clear()
        try:
            # saisir la sélection s'il y en a une (sinon -> except)
            t = self.selection_get()
            # et envoyer le texte sélectionné dans le clipboard
            self.clipboard_append(t)
        except:
            pass

    def coller(self):
        try:
            # trouver la sélection du clipboard
            t = self.selection_get(selection='CLIPBOARD')
            # selon le widget qui a le focus, mettre la sélection au bon endroit
            if self.focus_get()==self.saisie:
                self.saisie.insert(Tkinter.INSERT, t)
            elif self.focus_get()==self.resultat:
                self.resultat.insert(Tkinter.INSERT, t)
            else:
                pass
        except:
            pass

    def menupopup(self, evt):
        """déclenche l'affichage du menu pop-up à l'endroit de la souris sur la ligne de saisie"""
        ycoord = self.saisie.winfo_pointery()
        xcoord = self.saisie.winfo_pointerx()
        self.menuflottant.tk_popup(xcoord, ycoord)

    def execmenu(self,ch):
        """ exécuté quand il y a eu sélection d'un item du menu flottant 2ème niveau"""
        # quand l'item commence par "$", n'insère rien
        if ch[0]!="$":
            # élimination des éventuels arguments entre parenthèses s'il y a des parenthèses
            ip1=ch.find("(")
            if ip1>=0:
                ip2=ch.rfind(")")
                ch=ch[0:ip1+1] + ch[ip2:]
            # lecture de la position du curseur et de l'éventuel début d'une sélection dans la saisie
            a=self.saisie.index(Tkinter.ANCHOR)
            i=self.saisie.index(Tkinter.INSERT)
            if i<a:
                # si la sélection a été faite à l'envers (de droite à gauche), inverser a et i pour que i>a
                a,i=i,a
            if ip1>=0:
                # = la fonction a une parenthèse
                if a!=i:
                    # = il y a une sélection en cours => la sélection sera placée entre les parenthèses
                    s=self.saisie.get()
                    x=s[0:a] + ch[0:-1] + s[a:i] + ")" + s[i:]
                    #self.varsaisie.set(x)
                    self.saisie.delete(0,Tkinter.END)
                    self.saisie.insert(0, x)
                else:
                    # = il n'y a pas de sélection en cours => insertion normale
                    self.saisie.insert(Tkinter.INSERT, ch)
                # sélection ou pas, curseur positionné juste avant la parenthèse fermante
                self.saisie.icursor(i+len(ch)-1)
            else:
                # la fonction n'a pas de parenthèse => insertion sans tenir compte de la sélection
                self.saisie.insert(Tkinter.INSERT, ch)
                # curseur positionné après la partie insérée
                self.saisie.icursor(i+len(ch))

##############################################################################
def est_exe():
    """permet de savoir si l'exécution est en exe avec py2exe (Windows) ou en .py"""
    return (hasattr(sys, "frozen") or # nouveau py2exe
        hasattr(sys, "importers") or # ancien py2exe
        imp.is_frozen("__main__")) # tools/freeze

##############################################################################
def rep_exec():
    """donne le répertoire d'exécution de la calculatrice selon version .exe (Windows) ou .py"""
    if est_exe():
        # exécution .exe sous Windows avec py2exe
        return os.path.dirname(sys.executable)
    # exécution .py avec l'interpréteur Python
    return os.path.dirname(sys.argv[0])

##############################################################################
# lancement, affichage au centre de l'écran et exécution de la calculatrice
#
if __name__ == "__main__":

    try:
        setcheckinterval(20)
        fen=Tkinter.Tk()
        fen.title("CALCULEXT v1.40  - Calculatrice scientifique extensible -")
        app=Calculext(fen)
        centrefenetre(fen)
        fen.resizable(width=False, height=False)
        try:
            if sys.platform=='win32':
                fen.iconbitmap(rep_exec() + os.sep + 'icone.ico')
            elif sys.platform=='linux2':
                fen.iconbitmap('@' + rep_exec() + os.sep + 'icone.xbm')
        except:
            pass
        fen.mainloop()
    except:
        # cette sortie par except permet de tuer la calculatrice alors
        # qu'un calcul est en cours et ceci, sans message d'erreur
        pass
